/***********************************************************************

	File:			ui.h
	Author:		Ted Gould
	Time:			Thu May  6 00:42:57 EST 1999

	This is a file to hold all the information about ui.c so that it
	compiles nicely, and has everything that it needs to run.  Fun fun.

***********************************************************************/

#ifndef __UI_H_
#define __UI_H_

#define INPUT_MATRIX_SIZE  5

#define PLUG_IN_NAME_DILATE		"plug-in-dilate"
#define PLUG_IN_NAME_ERODE			"plug-in-erode"
#define PLUG_IN_NAME_OPENING		"plug-in-opening"
#define PLUG_IN_NAME_CLOSING		"plug-in-closing"
#define PLUG_IN_NAME_GRADIENT		"plug-in-gradient"

/* Saved GIMP values */
#define PLUG_IN_SAVED_CENTER_X			"plug-in-morpho-center-x"
#define PLUG_IN_SAVED_CENTER_Y			"plug-in-morpho-center-y"
#define PLUG_IN_SAVED_SIZE_OF_MATRIX	"plug-in-morpho-size-of-matrix"
#define PLUG_IN_SAVED_MASK					"plug-in-morpho-mask"

static void query (void);
static void run (gchar * name,
						gint	nparams,
						GParam	* param,
						gint	* nreturn_vals,
						GParam	**	return_vals);
GtkWidget * morph_create_window(void);
void brian_func(GDrawable * drawable, int matrix[][], int center_x, int center_y);
void default_global_values (GParam param);
void get_gimp_saved_values (void);
void put_gimp_saved_values (void);
GtkWidget * create_gtk_table(void);
void checkbox_change_value (gpointer data);
void center_callback (gpointer data);
GPixelRgn (* solve_which_function (char * name))(GDrawable *drawable, int Se[][], int Px, int Py);
GPixelRgn open_me_up (GDrawable *drawable, int matrix[][], int x, int y);
GPixelRgn close_me_down (GDrawable *drawable, int matrix[][], int x, int y);

/* Set up Plugin Info */
GPlugInInfo PLUG_IN_INFO = {
	NULL, /* init_proc */
	NULL, /* quit_proc */
	query, /* query_proc */
	run	/* run_proc */
	};

extern GDrawable * global_drawable;
extern int global_matrix[INPUT_MATRIX_SIZE][INPUT_MATRIX_SIZE];
extern int global_center_x, global_center_y;
extern GPixelRgn (* dofunc)(GDrawable *drawable, int Se[][], int Px, int Py);

#endif /* __UI_H_ */
